
#ifndef _PROPGADGET
#define _PROPGADGET
#include "layout.h"

class PropGadget : public MView, public BControl
{
	protected:	thread_id mousethread;
				BPoint clickpoint;

	private:	float	hprop;
				float	hval;
				float	vprop;
				float	vval;
				bool	vertical;
				bool	horizontal;
				void	(*callback)(PropGadget*,void*,float,float);
				void	*callbackarg;
				long	borderspacing;
				
	public:		PropGadget(float,float ,float, float, BBitmap* =NULL,
					 void (*func)(PropGadget*, void*, float, float)=NULL,
					 void *arg=NULL,
					 long extraspacing=0);
					 
				virtual ~PropGadget();

				BBitmap*	Pknob;
				BRect lastknobrect;

				virtual	void	Draw(BRect);
				virtual void	MouseDown(BPoint);
				static	long	_mousetracker(void *arg);
						void	_MouseTracker();

				void			SetProp(float,float);
				void			SetPropNoDraw(float,float);
				virtual void	FrameResized(float,float);
				void			ReDraw();
				inline float	Hval() {return hval;}
				inline float	Vval() {return 1.0-vval;}

				virtual	minimax	layoutprefs();
				virtual BRect	layout(BRect rect);
				virtual void	DrawContainer(BRect);
				virtual void	DrawKnob(BRect);
				virtual void	KeyDown(const char *bytes, int32 numbytes);
};


#define M_PROP_PROP		0
#define M_PROP_FIXED	1

#endif