
#include "appwin.h"
#include "layout.h"
#include "Leaf.h"


myapp::myapp(char *id)
	: BApplication(id)
{
}


void myapp::AboutRequested()
{
	BAlert	*myAlert;
	myAlert = new BAlert("","By Marco Nelissen","Neat!");
	myAlert->Go();
}

mywin::mywin(BRect r,char *name,window_type type,ulong mode)
	: BWindow(r,name,type,mode)
{
}

bool mywin::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return TRUE;
}

void mywin::MessageReceived(BMessage *message)
{
	switch ( message->what )
	{
		default:
			printf("received message: %08x\n",message->what);
			inherited::MessageReceived(message);
			break;
	}
}


void mywin::Show()
{
	minimax mpm;
	BRect cursize;
	
	mpm=(dynamic_cast<MView*>(ChildAt(0)))->layoutprefs();

//	SetSizeLimits(mpm.mini.x-1,mpm.maxi.x-1,mpm.mini.y-1,mpm.maxi.y-1);
	SetSizeLimits(mpm.mini.x-1,65536,mpm.mini.y-1,65536);
	cursize=Bounds();
	cursize.OffsetTo(0,0);
	cursize=(cursize|BRect(0,0,mpm.mini.x-1,mpm.mini.y-1))&BRect(0,0,mpm.maxi.x-1,mpm.maxi.y-1);
	ResizeTo(cursize.Width(),cursize.Height());
	inherited::Show();
}

void mywin::FrameResized(float width, float height)
{
#pragma unused(width,height)
	MView *top;
	BView *btop;
	BRect size;

	top=dynamic_cast<MView*>(btop=ChildAt(0));
	size=Bounds();
	if(top && top->lastsize != size)
	{
		top->lastsize = size;
		DisableUpdates();
		top->layout(size);
		EnableUpdates();
	}

	// Workaround for yet another bug in BeOS
	if(btop->Bounds() != Bounds())
		PostMessage(&BMessage(B_WINDOW_RESIZED));
	// end of workaround
}
